<?php

/**
 * nov_ka_num_dias_ant actions.
 *
 * @package    nomina
 * @subpackage nov_ka_num_dias_ant
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class nov_ka_num_dias_antActions extends sfActions {

    /**
     * Executes list actions
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");


        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by fecha_fin desc';
        }

        /*
         * Manejo de errores
         */
        try {

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /**
             * Variables
             */
            $id_tipo_doc = $request['id_tipo_doc'];
            $num_doc = $request['num_doc'];
            $id_tip_nov_ka = $request['id_tip_nov_ka'];

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 

id_novedad_kardex,
		id_tipo_doc,
		num_doc,
num_dias,
num_dias_ant,
nvl(num_dias,0) + nvl(num_dias_ant,0) as num_dias_ant_sum

from no_novedad_kardex
where 
id_tipo_doc = $id_tipo_doc
and num_Doc = '$num_doc'
and id_tip_nov_ka = $id_tip_nov_ka
and estado = 1
                    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 

id_novedad_kardex,
		id_tipo_doc,
		num_doc,
num_dias,
num_dias_ant,
nvl(num_dias,0) + nvl(num_dias_ant,0) as num_dias_ant_sum

from no_novedad_kardex
where 
id_tipo_doc = $id_tipo_doc
and num_Doc = '$num_doc'
and id_tip_nov_ka = $id_tip_nov_ka
and estado = 1
                    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            if (count($resultado) <= 0) {
                $resultado = array(
                    '0' => array(
                        'id_novedad_kardex' => 0,
                        'num_dias_ant_sum' => 0
                    )
                );
            }

            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_prenomina] Consulta exitosa.");
        } catch (Exception $ex) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
